From ffb9f27c98ccaf360c841ff4c8174410fc65515e Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 19 2017 15:42:53 +0000
Subject: [PATCH 7/24] Don't use fedmsg.d for default values


Otherwise those defaults can't be overridden by values in /etc/fedmsg.d.

---

diff --git a/hubs/app.py b/hubs/app.py
index fa24829..8072e1f 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -31,8 +31,7 @@ if 'HUBS_CONFIG' in os.environ:
     app.config.from_envvar('HUBS_CONFIG')
 
 fedmsg_config = get_fedmsg_config()
-session = hubs.models.init(
-    fedmsg_config.get('hubs.sqlalchemy.uri', 'sqlite:///'))
+session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'])
 datanommer.models.init(
     fedmsg_config.get('datanommer.sqlalchemy.uri', 'sqlite:///'))
 
diff --git a/hubs/default_fedmsg_config.py b/hubs/default_fedmsg_config.py
new file mode 100644
index 0000000..81198d6
--- /dev/null
+++ b/hubs/default_fedmsg_config.py
@@ -0,0 +1,58 @@
+config = {
+
+    # Fedmsg hub consumer
+    'hubs.consumer.enabled': True,
+
+    # Main database
+    'hubs.sqlalchemy.uri': 'sqlite:////var/tmp/hubs.db',
+
+    # For communication between fedmsg-hub and the cache worker farm
+    'hubs.redis.triage-queue-name': 'fedora-hubs-triage-queue',
+    'hubs.redis.work-queue-name': 'fedora-hubs-work-queue',
+
+    # Junk junk junk.. that we don't care about.  Drop it!
+    'hubs.junk_suffixes': [
+        'buildsys.tag',
+        'buildsys.untag',
+        'buildsys.rpm.sign',
+    ],
+
+    'endpoints': {
+        "fedora-infrastructure": [
+            "tcp://hub.fedoraproject.org:9940",
+        ]
+    },
+
+    'datanommer.sqlalchemy.uri':
+        'postgres://postgres:laksjdf@127.0.0.1/datanommer',
+
+    'fmn.url': 'https://apps.fedoraproject.org/notifications',
+
+    # Some configuration for the rule processors
+    "fmn.rules.utils.use_pkgdb2": False,
+    "fmn.rules.utils.pkgdb2_api_url": "http://209.132.184.188/api/",
+    "fmn.rules.cache": {
+        "backend": "dogpile.cache.dbm",
+        "expiration_time": 300,
+        "arguments": {
+            "filename": "/var/tmp/fmn-cache.db",
+        },
+    },
+
+    # Some configuration for the general hubs cache.
+    "fedora-hubs.cache": {
+        "backend": "dogpile.cache.dbm",
+        "expiration_time": -1,  # Expire every 1 second, for development
+        "arguments": {
+            "filename": "/var/tmp/fedora-hubs-cache.db",
+        },
+    },
+
+    # Run datanommer locally, just for development.
+    'datanommer.enabled': True,
+    'datanommer.sqlalchemy.url':
+        'postgres://postgres:laksjdf@127.0.0.1/datanommer',
+
+    # Only do one of these so we can try to not run out of memory.
+    'moksha.workers_per_consumer': 1,
+}
diff --git a/hubs/utils/__init__.py b/hubs/utils/__init__.py
index 8713806..80d239f 100755
--- a/hubs/utils/__init__.py
+++ b/hubs/utils/__init__.py
@@ -7,6 +7,8 @@ import fedmsg.config
 import fedmsg.meta
 from six.moves.urllib_parse import urlencode
 
+from hubs.default_fedmsg_config import config as default_fedmsg_config
+
 
 def get_fedmsg_config():
     try:
@@ -14,6 +16,11 @@ def get_fedmsg_config():
     except KeyError:
         filenames = None
     fedmsg_config = fedmsg.config.load_config(filenames=filenames)
+    # Only add default values if they don't exist yet.
+    for key, value in default_fedmsg_config.items():
+        if key not in fedmsg_config:
+            fedmsg_config[key] = value
+    # Meta processors
     fedmsg.meta.make_processors(**fedmsg_config)
     return fedmsg_config
 

